#!/bin/bash

. compilers.env

export FSFLAG='-cpp -I'

echo "#------------------#----------------------------------------------------------------------------------"
echo "# FUnit testing... #"
echo "#------------------#"
FUNIT_SCRIPTS=connection_m
cd src;
for F in ${FUNIT_SCRIPTS}; do

    TEST_STATUS=0;
    funit ${F} || TEST_STATUS=1;

    if [[ TEST_STATUS -gt 0 ]]; then
        echo "ERROR: Unit test failed!"
        exit -1;
    fi
done

echo "#---------------------#-------------------------------------------------------------------------------"
echo "# Memcheck testing... #"
echo "#---------------------#"
MEM_TEST_SCRIPTS=connection_m_mem_leak_test.out net_m_mem_leak_test.out

cd ../build;

for F in ${MEM_TEST_SCRIPTS}; do
    echo "Running ${F}..."
    TEST1_MEM_STATUS=`valgrind --leak-check=yes build/${F} 2>&1 | grep 'LEAK SUMMARY' | wc -l`

    if [[ TEST1_MEM_STATUS -gt 0 ]]; then
        echo "ERROR: Memory leaks detected in ${F}!"
        exit -1
    fi
    echo "${F} OK"
done

echo "#---------------------------#"
echo "# No memory leaks detected. #"
echo "#---------------------------#"
